﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace WinGrid_CS91_CLR2_CellSpanUsingCreationFilter
{
    class ColSpan : Infragistics.Win.IUIElementCreationFilter
    {

        #region Implementation of IUIElementCreationFilter
        public void AfterCreateChildElements(Infragistics.Win.UIElement parent)
        {
            //Nothing in here.			
        }
        public bool BeforeCreateChildElements(Infragistics.Win.UIElement parent)
        {
            //Declare some variables
            Infragistics.Win.UltraWinGrid.CellUIElement objCellUIElement;
            Infragistics.Win.UltraWinGrid.UltraGridCell objCell;

            if (parent is Infragistics.Win.UltraWinGrid.CellUIElement)
            {
                //Get a reference to the cell, and the cells ui element.
                objCellUIElement = (Infragistics.Win.UltraWinGrid.CellUIElement)parent;

                objCell = (Infragistics.Win.UltraWinGrid.UltraGridCell)objCellUIElement.GetContext(typeof(Infragistics.Win.UltraWinGrid.UltraGridCell));

                //If the cell being created is from column 1 and its BackColor is PowderBlue 
                //(You can use any flag you feel is appropriate in place of the color test)
                if ((objCell.Column.Index == 0) && (objCell.Appearance.BackColor == Color.PowderBlue))
                {
                    //This is a cell that should span two columns, so we stretch its rectangle.
                    objCellUIElement.Rect = new Rectangle(20, objCellUIElement.Rect.Y, objCell.Width + objCell.Row.Cells[objCell.Column.Index + 1].Width, objCellUIElement.Rect.Height);
                }
                //If the cell is from column 2.
                if (objCell.Column.Index == 1)
                {
                    //We check to see if the cell next to it should span into its space.
                    if (objCell.Row.Cells[objCell.Column.Index - 1].Appearance.BackColor == Color.PowderBlue)
                    {
                        //Here we are hiding the cell by shrinking its height and width down to 0.								
                        objCellUIElement.Rect = new Rectangle(objCellUIElement.Rect.X, objCellUIElement.Rect.Y, 0, 0);
                        //Return true to let the grid know that we handled the event.
                        return true;
                    }
                }
            }

            //Return false to let the grid know we did not handle the event. 
            return false;
        }
        #endregion

      
    }


}
